diff -BbruN freeswan-1.91.orig/pluto/openssl.h freeswan-1.91/pluto/openssl.h
--- freeswan-1.91.orig/pluto/openssl.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/pluto/openssl.h	Tue Jul  3 02:54:53 2001
@@ -0,0 +1,142 @@
+#ifdef OPENSSL
+#ifndef OPENSSL_INC_H
+#define OPENSSL_INC_H
+
+#include <openssl/evp.h>
+#include <openssl/err.h>
+#include <openssl/pem.h>
+#include <openssl/x509.h>
+#include <openssl/x509v3.h>
+#include <openssl/safestack.h>
+
+#include <freeswan.h>
+
+#include "xmap.h"
+
+struct _x509_cert_node {
+  X509 *x;
+  struct _x509_cert_node *next;
+};
+
+typedef struct _x509_cert_node *X509_cert_list;
+
+typedef bool discrim_fn( X509 *x, STACK_OF(XMAP) *lu,
+			 struct payload_digest *const id_pld, bool strict);
+
+extern bool make_lookups(STACK_OF(XMAP) **lu, const char *spec );
+extern bool check_idtype_and_path( struct connection *c, const char *spec );
+
+extern void log_err( void );
+extern void load_cert_and_key( const char *cert, const char *key,
+			       X509 **x, EVP_PKEY **k, char *conn_name );
+extern bool use_openssl( struct connection *c );
+extern STACK_OF(X509) *
+	peer_cert_list( STACK_OF(XMAP) *lu,
+		int type,
+		X509 *cert, struct payload_digest *const id_pld,
+		bool strict );
+extern STACK_OF(X509) *extract_STACK_OF_X509_from_PKCS7 (PKCS7 *p7);
+extern STACK_OF(X509_CRL) *extract_STACK_OF_X509_CRL_from_PKCS7 (PKCS7 *p7);
+
+extern bool have_rsa_key( struct state *st );
+extern bool have_dss_key( struct state *st );
+extern bool have_rsa_keypair( struct state *st );
+extern bool have_elgamal_keypair( struct state *st );
+
+extern bool verify_certificate( X509 *x, STACK_OF(XMAP) *lu,
+				const char *path, bool strict );
+
+extern u_int32_t parse_options( const char *s );
+
+extern int DSA_sign_raw(unsigned char *dgst,int dlen,
+			unsigned char *sig, unsigned int *siglen, DSA *dsa);
+
+extern int DSA_verify_raw(const unsigned char *dgst,int dgst_len,
+			  unsigned char *sigbuf, int siglen, DSA *dsa);
+
+#define ERR_LIB_ELGAMAL 127
+
+#define ELGAMAL_F_ELGAMAL_PRIVATE_DECRYPT 100
+#define ELGAMAL_F_ELGAMAL_PUBLIC_ENCRYPT  101
+
+#define ELGAMAL_R_UNKNOWN_PADDING_TYPE      100
+#define ELGAMAL_R_DATA_GREATER_THAN_MOD_LEN 101
+#define ELGAMAL_R_PADDING_CHECK_FAILED      102
+
+#define ELGAMAL_PKCS1_PADDING RSA_PKCS1_PADDING
+#define ELGAMAL_PKCS1_OAEP_PADDING RSA_PKCS1_OAEP_PADDING
+#define ELGAMAL_NO_PADDING RSA_NO_PADDING
+
+#define ElGamalerr(f, r) ERR_PUT_error(ERR_LIB_ELGAMAL, (f), (r), ERR_file_name, __LINE__)
+
+void ERR_load_ElGamal_strings( void );
+int ElGamal_public_check( DSA *dsa );
+int ElGamal_public_encrypt( int flen, unsigned char *from,
+			    unsigned char *to,
+			    DSA *dsa, int padding );
+int ElGamal_private_decrypt( int flen, unsigned char *from,
+			     unsigned char *to,
+			     DSA *dsa, int padding );
+
+/* Function pointer pointing to an encryption routine */
+typedef void encryptor_fn( chunk_t *ch, struct state *c );
+
+extern bool valid_ciphertext_length( const u_int32_t len,
+				     struct connection *c );
+extern bool privkey_decrypt_chunk ( chunk_t *ch, struct state *c );
+extern bool pubkey_encrypt_chunk ( chunk_t *ch, struct state *c );
+
+/* get the other end's cert based */
+extern bool have_othercert( struct connection *c, int type );
+
+/* Macro to duplicate Private key. Used in unshare_connection_strings */
+#define EVP_PKEY_dup(pkey) \
+  (EVP_PKEY *)ASN1_dup((int (*)())i2d_PrivateKey, \
+  (char *(*)())d2i_AutoPrivateKey,(char *)pkey)
+
+/* convert EVP_PKEY to freeswan's RSA_public_key */
+extern const struct RSA_public_key *fs_RSA ( EVP_PKEY *evp_pkey );
+
+#if 0 /* an interesting struct for certs */
+struct x509cert {
+  chunk_t        certificate;
+  chunk_t          tbsCertificate;
+  u_int              version;
+  chunk_t            serialNumber;
+                /*   signature */
+  chunk_t            sigAlg;
+  chunk_t            issuer;
+                /*   validity */
+  chunk_t              notBefore;
+  chunk_t              notAfter;
+  chunk_t            subject;
+                /*   subjectPublicKeyInfo */
+  enum pubkey_alg      subjectPublicKeyAlgorithm;
+                /*     subjectPublicKey */
+  chunk_t                modulus;
+  chunk_t                publicExponent;
+  chunk_t            issuerUniqueID;
+  chunk_t            subjectUniqueID;
+                /*   v3 extensions */
+                /*   extension */
+                /*     extension */
+                /*       extnID */
+                /*        critical */
+                /*        extnValue */
+                /*          generalNames */
+  chunk_t                     dnsName;
+  chunk_t                     ipAddress;
+  chunk_t                     rfc822Name;
+                /* signatureAlgorithm */
+  chunk_t            algorithm;
+  chunk_t          signature;
+};
+#endif
+
+/* to lookup CRLs */
+extern X509_CRL *lookup_crl(STACK_OF(XMAP) *lu, X509_NAME *name);
+
+#endif
+#endif
+
+
diff -BbruN freeswan-1.91.orig/pluto/openssl_defs.h freeswan-1.91/pluto/openssl_defs.h
--- freeswan-1.91.orig/pluto/openssl_defs.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/pluto/openssl_defs.h	Tue Jul  3 02:54:53 2001
@@ -0,0 +1,5 @@
+
+#define FILE_NAME_LIMIT 80
+#define PATH_NAME_LIMIT 256
+#define CERT_OPTIONS_LIMIT 128
+#define MAX_OTHER 2 /* only know about two type of certificate at the moment (RSA,DSA) */
